<template>
  <q-input
    autogrow
    borderless
    v-model="input"
    class="code-block"
    input-class="text-grey-10"
    input-style="max-height: 50vh;"
    label="Add your code here..."
    @keydown="handleKeydown"
    spellcheck="false"
  >
  </q-input>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue';

const emit = defineEmits<{
  update: [value: string];
}>();

const input = ref<string>('');
// Emit the new input value
watch(input, () => {
  emit('update', input.value);
});

// Record of the closing characters
const closingCharacter: Record<string, string> = {
  '{': '}',
  '[': ']',
  '(': ')',
  '<': '>',
  '"': '"',
};

// Function to handle custom keydown events
const handleKeydown = (e: KeyboardEvent): void => {
  const textArea = e.target as HTMLTextAreaElement; // Get the text input field

  const start: number = textArea.selectionStart || 0;
  const end: number = textArea.selectionEnd || 0;

  if (e.key === 'Tab') {
    e.preventDefault();
    onTabKey(textArea, start, end);
  } else if (e.key === 'Enter') {
    e.preventDefault();
    onEnterKey(textArea, start, end);
  } else if (e.key in closingCharacter) {
    e.preventDefault();
    onMatchingKey(textArea, start, end, e.key);
  }
};

function onTabKey(
  textArea: HTMLTextAreaElement,
  start: number,
  end: number,
): void {
  const selectedText: string = textArea.value.substring(start, end);
  const lines: string[] = selectedText.split('\n'); // Split the selected text into lines

  // Indent the selected text
  const indentedText: string = lines.map((line) => '    ' + line).join('\n');

  // Insert a tab character before the selected text
  input.value =
    textArea.value.substring(0, start) +
    indentedText +
    textArea.value.substring(end);

  // Move the cursor to the end of the inserted text
  setTimeout(() => {
    textArea.setSelectionRange(start + 4, start + 4);
  });
}

function onEnterKey(
  textArea: HTMLTextAreaElement,
  start: number,
  end: number,
): void {
  let lineStart: number = textArea.value.lastIndexOf('\n', start - 1); // Get the entire line before the cursor

  // If there is no line before the cursor, start at the beginning of the document
  // Else start at the beginning of the line, ignoring the last '\n' found
  if (lineStart === -1) lineStart = 0;
  else lineStart += 1;

  const selectedText: string = textArea.value.substring(lineStart, end);
  const leadingSpaces: string[] | null = selectedText.match(/^\s*/);

  let indentation: string = '';

  // Create an indentation string
  if (leadingSpaces) {
    let indentationLevel: number = leadingSpaces[0].length;
    for (let i = 0; i < indentationLevel; i++) indentation += ' ';
  }

  let matchingIndentation: string = '';

  // Check if the enter is called between two matching characters
  // If it is, indent the middle row and add a new line
  if (
    start > 0 &&
    start < textArea.value.length &&
    textArea.value[start] === closingCharacter[textArea.value[start - 1]]
  ) {
    matchingIndentation += '\n';
    matchingIndentation += indentation;

    indentation += '    ';
  }

  // Add new line and indentation
  input.value =
    textArea.value.substring(0, start) +
    '\n' +
    indentation +
    matchingIndentation +
    textArea.value.substring(end);

  // Move the cursor to the end of the inserted text
  setTimeout(() => {
    textArea.setSelectionRange(
      start + indentation.length + 1,
      start + indentation.length + 1,
    );
  });
}

function onMatchingKey(
  textArea: HTMLTextAreaElement,
  start: number,
  end: number,
  character: string,
): void {
  // Add the closing character
  input.value =
    textArea.value.substring(0, start) +
    character +
    closingCharacter[character] +
    textArea.value.substring(end);

  // Move the cursor between the two matching characters
  setTimeout(() => {
    textArea.setSelectionRange(start + 1, start + 1);
  });
}
</script>

<style scoped lang="scss">
.code-block {
  margin: 12px 0;
  padding: 0 12px;
  border-radius: 14px;
  overflow: hidden;
  box-shadow: 0 0 40px rgba(0, 0, 0, 0.2);
  transition: all 0.3s ease;
  backdrop-filter: blur(10px) !important;
  font-family: 'Roboto Mono', monospace;
}

.code-block:hover {
  background-color: rgba(0, 0, 0, 0.02) !important;
}
</style>
